import React, { useRef, useEffect, useImperativeHandle } from 'react';
import { View, ScrollView } from '@tarojs/components'
import './index.scss'

const Layout = ({ children }, ref) => {
    const scrollRef = useRef()

    useImperativeHandle(ref, () => ({
        offsetHeight: () => console.log(12312) || scrollRef.current.offsetHeight
    }))

    return <ScrollView scrollY className='scrolllayout' ref={scrollRef} >
        <View className='page-container' >
            {children}
        </View>
    </ScrollView>
}

export default React.forwardRef(Layout);
