import React, { useState } from "react";
// import { useEffect, useLayoutEffect, useReducer, useState, useContext, useRef, useCallback, useMemo } from '@tarojs/taro'
import Taro, { useDidShow } from "@tarojs/taro";
import { View, Text, Image } from "@tarojs/components";
import Tab from "../../compents/tab/index";
import Tags from "../../compents/tags/index";
import "./index.scss";
import { AtFloatLayout } from "taro-ui";
import getQueryValue from "../../util/getQueryValue";
import request, { uploadFiles } from "../../util/request";
import groupby from "lodash.groupby";
import NoData from "@/compents/NoData";
import IsLogin from "../../layout/IsLogin";

const index = props => {
  const { query } = getQueryValue();

  const [isOpened, setIsOpened] = useState(false);
  const [labelState, setLabelState] = useState(false);
  const [list, setList] = useState({});
  const [labelList, setLabelList] = useState([]);
  const [data, setData] = useState([]);
  const [tagList, setTagList] = useState([]);

  let [arrList, setArrList] = useState({});
  useDidShow(() => {
    getImageList();
    getMateTagGroupList();
  });

  const getMateTagGroupList = () => {
    request({
      url: "/taMateTagGroup",
      params: { pageSize: 9999 }
    }).then(res => {
      const { records, ...page } = res.data.data;
      setTagList(records);
    });
  };

  const getImageList = () => {
    request({
      url: "/taMetaImageTag",
      params: { tagIds: query, pageSize: 9999 }
    }).then(res => {
      const { records, ...page } = res.data.data;
      setList(groupby(records, item => item.imageId));
    });
  };
  const updateImage = () => {
    Taro.chooseImage({
      sourceType: ["album"],
      success: res => {
        const tempFilePaths = res.tempFilePaths;
        uploadFiles(tempFilePaths, "/api/mp/taMetaImage").then(res => {
          console.log(res, "uploadFiles");
          const newInfo = {
            newImage: res[0].imageId,
            newTags: data.map(x => x.tagId)
          };
          updatainfo(newInfo,'image');
        });
      }
    });

    setIsOpened(false);
  };

  const ontagsClick = () => {
    const newInfo = {
      newImage: data[0].imageId,
      newTags: labelList.map(x => x.tagId)
    };
    updatainfo(newInfo,'tag');
  };

  const updatainfo = (newInfo,type) => {
    const oldinfo = {
      originImage: data[0].imageId,
      originTags: data.map(x => x.tagId)
    };
    request({
      url: "/taMetaImageTag",
      data: { ...oldinfo, ...newInfo },
      method: "put"
    }).then(() => {
      Taro.showModal({
        title: "修改成功",
        content:type==='tag'? "修改标签请重新查询":'',
        showCancel: false,
        success: function(res) {
          if (res.confirm) {
            console.log("用户点击确定");
            getImageList();
            setLabelState(false);
          } else if (res.cancel) {
            console.log("用户点击取消");
          }
        }
      });
    });
  };

  const updateLabel = e => {
    setIsOpened(false);
    setLabelState(true);
  };
  const handleClose = e => {
    // console.log(e, "111");

    setIsOpened(false);
  };

  const deleteImage = e => {
    Taro.showModal({
      title: "确定删除该图片吗？",
      cancelColor: "#d2d2d2",
      confirmColor: "#274191",
      success: function(res) {
        if (res.confirm) {
          console.log("用户点击确定");

          setIsOpened(false);
          request({
            url: `/taMetaImageTag`,
            params: { ids: data.map(x => x.serialNo).join(",") },
            method: "delete"
          }).then(res => {
            // const { records, ...page } = res.data.data;
            // setList(groupby(records, item => item.imageId));
            Taro.showModal({
              title: "删除成功",
              showCancel: false,
              success: function(res) {
                if (res.confirm) {
                  console.log("用户点击确定");
                  getImageList();
                } else if (res.cancel) {
                  console.log("用户点击取消");
                }
              }
            });
          });

          // Taro.showModal({
          //   title: `改标签组有${row.user.number}个标签仍在使用。请先清空标签，再删除标签组`,
          //   showCancel: false,
          //   // cancelColor:'#d2d2d2',
          //   confirmColor: "#274191",
          //   success: function (res) {
          //     if (res.confirm) {
          //       console.log('用户点击确定')

          //     } else if (res.cancel) {
          //       console.log('用户点击取消')
          //     }
          //   }
          // })
        } else if (res.cancel) {
          setIsOpened(false);
        }
      }
    });
  };

  const onLabelChange = (e, index) => {
    let newArrArrList = {
      ...arrList,
      [index]: e
    };
    setArrList(newArrArrList);
    let newArr = Object.values(newArrArrList).reduce((pre, cur) => {
      return pre.concat(cur);
    }, []);
    setLabelList([...newArr]);
  };

  return (
    <IsLogin>
      <View className="imglist" style={{height: '100vh'}}>
        <NoData nodata={Object.keys(list).length === 0}>
          {!labelState && (
            <View style={{ padding: "0 30px" }}>
              {Object.keys(list).map(item => {
                return (
                  <View className="imglist-card" key={item}>
                    <View
                      className="imglist-card-tags"
                      style={{ display: "flex" }}
                    >
                      {/* imageimageimageimage34 */}
                      {list[item].map(x => {
                        return <View className="tag" key={x.tagName}>{x.tagName}</View>;
                      })}
                    </View>
                    <Image
                      src={list[item][0].image}
                      style={{ width: "100%" }}
                      onClick={() => {
                        setData(list[item]);
                        setIsOpened(true);
                      }}
                    ></Image>
                  </View>
                );
              })}
            </View>
          )}

          {labelState && (
            <View>
              <View style={{ textAlign: "center" }}>
                <View style={{}}>
                  {tagList.map((item, index) => {
                    return (
                      <View className="imglist-tagcard" key={item.name}>
                        <Text>{item.name}</Text>
                        <Tags
                          list={item.taMateTagList}
                          onChange={e => onLabelChange(e, index)}
                          style={{ marginTop: "90rpx" }}
                        />
                      </View>
                    );
                  })}
                </View>
              </View>
            </View>
          )}
        </NoData>
        {labelState && (
          <Tab
            pageState="3"
            value={["取消", "选择"]}
            onClick={[e => setLabelState(false), e => ontagsClick()]}
          ></Tab>
        )}
        <AtFloatLayout
          isOpened={isOpened}
          onClose={() => handleClose()}
          style={{ zIndex: "1000" }}
        >
          <View className="floatmodel">
            <View onClick={() => updateLabel('tag')}>更改标签</View>
            <View onClick={() => updateImage('image')}>更换图片</View>
            <View onClick={() => deleteImage()}>删除</View>
            <View
              style={{ color: "#d2d2d2" }}
              onClick={() => setIsOpened(false)}
            >
              取消
            </View>
          </View>
        </AtFloatLayout>
      </View>
    </IsLogin>
  );
};

export default index;
