import React, { useState } from "react";
// import { useEffect, useLayoutEffect, useReducer, useState, useContext, useRef, useCallback, useMemo } from '@tarojs/taro'
import Taro, { useDidShow } from "@tarojs/taro";
import { View ,Text } from "@tarojs/components";
import Layout from "../../layout/index";
import Tab from "../../compents/tab/index";
import Tags from "../../compents/tags/index";
import request from "../../util/request";
import NoData from "@/compents/NoData";
import "./index.scss";
import IsLogin from "../../layout/IsLogin";

const index = props => {
  let [arrList, setArrList] = useState({});
  const [labelList, setLabelList] = useState([]);
  const [list, setList] = useState([]);


  useDidShow(() => {
    getMateTagGroupList();
  });

  const getMateTagGroupList = () => {
    request({
      url: "/taMateTagGroup",
      params: { pageSize: 1, pageSize: 9999 }
    }).then(res => {
      const { records, ...page } = res.data.data;
      setList(records);
    });
  };

  const onLabelChange = (e, index) => {
    let newArrArrList = {
      ...arrList,
      [index]: e
    };
    setArrList(newArrArrList);
    let newArr = Object.values(newArrArrList).reduce((pre, cur) => {
      return pre.concat(cur);
    }, []);
    setLabelList([...newArr]);
  };

  const onClick = () => {
    const query = labelList.map(x => x.tagId).join(",");
    Taro.navigateTo({
      url: `/pages/imglist/index?query=${query}`
    });
  };

  return (
    <IsLogin>
      <View className="material">
        <Layout>
          <NoData nodata={!list.length}>
            {list.map((item, index) => {
              return (
                <View className="material-card" key={index}>
                  <Text>{item.name}</Text>
                  <Tags
                    list={item.taMateTagList}
                    onChange={e => onLabelChange(e, index)}
                  ></Tags>
                </View>
              );
            })}
          </NoData>
        </Layout>
        <Tab
          pageState="3"
          value={["取消", "开始查询"]}
          onClick={[
            e =>
              Taro.navigateBack({
                delta: 1
              }),
            e => onClick(e)
          ]}
        ></Tab>
      </View>
    </IsLogin>
  );
};

export default index;
